note
   description: "Updating interface for objects that should be notified of%
   % changes in a Subject"

deferred class OBSERVER

--------------------------
feature

update deferred end
  -- Update the observer's view on 'subject'

make (s : like subject)
  -- Creation and initialization
  require
    s_not_void: s /= Void
  do
    subject := s
    subject.attach(Current)
  end

--------------------------
feature {ANY} -- Queries

subject : SUBJECT

detach
  -- Detach from subject
  do
    subject.detach(Current)
    subject := Void
  end

invariant
  subject_observer: subject /= Void implies subject.is_attached_to(Current)

end
